﻿"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var GtVisiblePipe = (function () {
    function GtVisiblePipe() {
        // TODO: move to helper functions
        /** Sort by column order */
        this.getColumnOrder = function (a, b) {
            if (a.columnOrder < b.columnOrder)
                return -1;
            if (a.columnOrder > b.columnOrder || typeof a.columnOrder === 'undefined')
                return 1;
            return 0;
        };
    }
    GtVisiblePipe.prototype.transform = function (array, settings) {
        var visibleColumns = settings.sort(this.getColumnOrder).map(function (setting) {
            if (setting.visible !== false && setting.enabled !== false) {
                return setting.objectKey;
            }
        });
        var columns = array.filter(function (column) {
            return visibleColumns.indexOf(column.objectKey) !== -1;
        }).sort(function (a, b) {
            return visibleColumns.indexOf(a.objectKey) < visibleColumns.indexOf(b.objectKey) ? -1 : 1;
        });
        return columns;
    };
    return GtVisiblePipe;
}());
GtVisiblePipe.decorators = [
    { type: core_1.Pipe, args: [{
                name: 'gtVisible'
            },] },
];
/** @nocollapse */
GtVisiblePipe.ctorParameters = function () { return []; };
exports.GtVisiblePipe = GtVisiblePipe;
//# sourceMappingURL=gt-visible.pipe.js.map